<template>
  <v-dialog
    v-model="dialog"
    width="768"
    :max-height="isMobile ? undefined : '85%'"
    scrollable
    :fullscreen="isMobile"
    @click:outside="onClickOutside"
  >
    <template v-slot:activator="{ props: activatorProps }">
      <slot name="activator" :props="activatorProps">
        <svn-pro-button
          v-bind="activatorProps"
          variant="text"
          color="primary"
          text="Open Modal"
        >
        </svn-pro-button>
      </slot>
    </template>

    <template v-slot:default="{ isActive }">
      <v-card
        :title="title"
        :rounded="isMobile ? undefined : 'lg'"
      >
        <v-divider class="border-t border-opacity-100 border-borderColor"></v-divider>

        <template v-if="isMobile" #prepend>
          <svn-pro-icon-button
            icon="mdi-close"
            variant="text"
            color="onSurfaceVariant"
            @click="onClickClose"
          >
          </svn-pro-icon-button>
        </template>

        <template v-if="!(isMobile && stickyBottom)" #append>
          <svn-pro-button
            v-if="isMobile"
            variant="text"
            :text="actionOneTitle"
            :loading="primaryLoading"
            color="primary"
            @click="onClickActionOne"
          >
          </svn-pro-button>

          <svn-pro-icon-button
            v-else
            icon="mdi-close"
            variant="text"
            color="onSurfaceVariant"
            @click="onClickClose"
          />
        </template>

        <v-card-text :style="`height: ${contentHeight}px;`">
          <slot name="text">
            <svn-pro-text bodyMedium>
              {{ contentText }}
            </svn-pro-text>
          </slot>
        </v-card-text>

        <v-card-actions
          v-if="(actionOneTitle || actionTwoTitle) && stickyBottom"
          class="w-full flex md:!flex-row gap-3"
          :class="[isMobile ? 'bgStyle' : '', horizontalButtons ? 'flex-row h-[72px] !gap-2' : 'flex-col-reverse']"
        >
          <v-spacer class="hidden md:!flex"></v-spacer>

          <svn-pro-button
            v-if="actionTwoTitle"
            :class="horizontalButtons ? 'flex-1' : 'w-full md:!w-fit'"
            variant="outlined"
            color="primary"
            class="!ms-0 px-4"
            :text="actionTwoTitle"
            @click="onClickActionTwo"
          >
          </svn-pro-button>

          <svn-pro-button
            v-if="actionOneTitle"
            variant="flat"
            color="primary"
            class="!ms-0 px-4"
            :class="horizontalButtons ? 'flex-1' : 'w-full md:!w-fit'"
            :loading="primaryLoading"
            :disabled="primaryDisabled"
            :text="actionOneTitle"
            @click="onClickActionOne"
          >
          </svn-pro-button>
        </v-card-actions>
      </v-card>
    </template>
  </v-dialog>
</template>

<script setup>
import SvnProText from "../styles/SvnProText.vue"
import SvnProIconButton from "../button/SvnProIconButton.vue";
import SvnProButton from "../button/SvnProButton.vue"
import { ref, onMounted, onUnmounted } from "vue";

const dialog = ref(false)
const isMobile = ref(false)

const emit = defineEmits(['click-primary-button', 'click-secondary-button', 'click-outside', 'click-close'])

const props = defineProps({
  title: {
    type: String,
    default: "Modal title",
  },
  contentText: {
    type: String,
    default: undefined,
  },
  contentHeight: {
    type: Number,
    default: undefined,
  },
  actionOneTitle: {
    type: String,
    default: undefined,
  },
  actionTwoTitle: {
    type: String,
    default: undefined,
  },
  primaryLoading: {
    type: Boolean,
    default: false,
  },
  primaryDisabled: {
    type: Boolean,
    default: false,
  },
  closeButtonClosesModal: {
    type: Boolean,
    default: true,
  },
  stickyBottom: {
    type: Boolean,
    default: true,
  },
  horizontalButtons: {
    type: Boolean,
    default: false,
  }
})

const onClickActionOne = () => {
  emit('click-primary-button')
}

const onClickActionTwo = () => {
  emit('click-secondary-button')
}

const onClickClose = () => {
  if (props.closeButtonClosesModal) {
    dialog.value = false
  }
  emit('click-close')
}

const onClickOutside = () => {
  emit("click-outside")
}

onMounted(() => {
  isMobile.value = window.innerWidth < 768
  window.addEventListener("resize", handleWindowResize)
})

onUnmounted(() => {
  window.removeEventListener("resize", handleWindowResize)
})

const handleWindowResize = (e) => {
  isMobile.value = e.target.innerWidth < 768
}

defineExpose({
  dialog
})
</script>

<style scoped>
.bgStyle {
  background: linear-gradient(0deg, var(--sys-primary-overlay-v-theme-primary-overlay-multiplier-024, rgba(62, 82, 202, 0.24)) 0%, var(--sys-primary-overlay-v-theme-primary-overlay-multiplier-024, rgba(62, 82, 202, 0.24)) 100%), var(--sys---v-theme-surface, #FBF9F9);
}
</style>